/*
Lexmark 1100 printer driver for Linux
Copyright (C) 1999   Tim Engler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _ERROR_DIFFUSION_ALG_H
#define _ERROR_DIFFUSION_ALG_H

#include "MapAlgorithm.h"
#include "Map.h"

/* Runs error diffusion. Can only be run against one map at a time
 */
class ErrorDiffusionAlg : public MapAlgorithm
{
 private:
	Map *errorMap;

	int noErrorCounter[3]; /* Keep track of any positive error diffusion. Since most ghostscript images contain
							  a lot of static white, there is no error diffusion needed so it saves time to turn
							  off error diffusion for these large white areas
						   */

	int brightness; // brightness of image(max 255)
	
 public:
	ErrorDiffusionAlg(int brightness);
	~ErrorDiffusionAlg();

	void touchDataLines(Map *imageMap, int start,int len,void *ptr);
};

#endif

