/*
Lexmark 1100 printer driver for Linux
Copyright (C) 1999   Tim Engler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _LEXMARK_PROTOCOL_H
#define _LEXMARK_PROTOCOL_H

#include "Coord.h"
#include "PaintLine.h"
#include "Writer.h"
#include "Map.h"
#include "PrinterProtocol.h"
#include "Rect.h"

class LexmarkProtocol
{
 public:
	virtual void startPage()=0;
	virtual void adjustPositions(int *startX, int *startY, int *endX)=0;
	virtual void startPaint(int startX, int startY, int size)=0;
	virtual void endPaint()=0;
	virtual void endPage()=0;
	virtual void paint(int sx,int x, int y, int color)=0;

	virtual int getLeftBorder()=0;
	virtual int getTopBorder()=0;
	virtual int getRightBorder()=0;
	virtual int getBottomBorder()=0;

	virtual class Jet **createJets(int *numJets, Map *imageMap)=0;

	//returns the page size in logical printer pixels
	virtual Rect getPageSize(int pageType)=0;
};

#endif

