/*
Lexmark 1100 printer driver for Linux
Copyright (C) 1999   Tim Engler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include "PPMRawAlg.h"
#include "errors.h"
#include "PPMRaw.h"

#define PPM_RAW_SIZE 3

PPMRawAlg::PPMRawAlg(Reader *reader,bool readMagic)
{
	this->reader = reader;
	this->width = -1;
	this->height = -1;
	this->maxval = 0;
	
	PPMRaw::readHeader(&width,&height,&maxval, reader, readMagic);

	this->dataStart = reader->tell();
}

/* from MapAlgorithm */
void PPMRawAlg::touchDataLines(Map *map, int start,int len,void *ptr)
{
    //seek to the right spot
	this->reader->seek(dataStart + start * width * PPM_RAW_SIZE,0);

    //read the data
	this->reader->read(ptr,len * width * PPM_RAW_SIZE, 1);
}

//skips to the end of the image
void PPMRawAlg::skipToEnd()
{
	this->reader->seek(dataStart + height * width * PPM_RAW_SIZE,0);
}
