/*
Lexmark 1100 printer driver for Linux
Copyright (C) 1999   Tim Engler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// stores all the information to paint a single brush stroke of the printer head(used by LexmarkProtocol)
#include "PaintLine300c.h"
#include <string.h>
#include <stdio.h>

PaintLine300c::PaintLine300c(int x, int y, int size)
{
    this->size = size;
	this->x = x;
	this->y = y;

	data = new char *[3];

    data[0] = (char *)memset(new char [size*2],0,size*2);
    data[1] = (char *)memset(new char [size*2],0,size*2);
    data[2] = (char *)memset(new char [size*2],0,size*2);
}

PaintLine300c::~PaintLine300c()
{
	delete data[0];
	delete data[1];
	delete data[2];
	delete data;
}

//paints a droplet of paint
void PaintLine300c::paint(int sx,int x, int nozzle, int color)
{
	int index = (x - sx) * 2;
	if(nozzle >= 8)
	{
		nozzle -= 8;
		index ++;
	}
	
    data[color][index] |= 1 << (7 - nozzle);
}
