/*
Lexmark 1100 printer driver for Linux
Copyright (C) 1999   Tim Engler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _READER_H
#define _READER_H
#include <stdio.h>

class Reader
{
 private:
	FILE *fd;

	bool supportsSeek;
	int filePos;
	
 public:
	/* string will be ended with '\0'. No more then max_len characters will be put into line including '\0'
	   Returns the number of characters actually read, or -1 if hit EOF on first character */
	int readLine(char *line, int max_len);

	/* runs fseek on the underlying stream, returning results of command */
	int seek(int offset, int whence);

	/* runs fread on the underlying stream, returning results of command */
	size_t read(void *ptr, size_t size, size_t nmemb);

	/* runs tell on the underlying stream, returning results of command */
	long tell();

	Reader(FILE *fd, bool supportsSeek);
};



#endif
